# USB_STM32



## Getting started

To make it easy for you to get started with GitLab, here's a list of recommended next steps.

Already a pro? Just edit this README.md and make it your own. Want to make it easy? [Use the template at the bottom](#editing-this-readme)!

## Add your files

- [ ] [Create](https://docs.gitlab.com/ee/user/project/repository/web_editor.html#create-a-file) or [upload](https://docs.gitlab.com/ee/user/project/repository/web_editor.html#upload-a-file) files
- [ ] [Add files using the command line](https://docs.gitlab.com/ee/gitlab-basics/add-file.html#add-a-file-using-the-command-line) or push an existing Git repository with the following command:

```
cd existing_repo
git remote add origin https://gitlab.com/sebasms1.99/usb_stm32.git
git branch -M main
git push -uf origin main
```

## Integrate with your tools

- [ ] [Set up project integrations](https://gitlab.com/sebasms1.99/usb_stm32/-/settings/integrations)

## Collaborate with your team

- [ ] [Invite team members and collaborators](https://docs.gitlab.com/ee/user/project/members/)
- [ ] [Create a new merge request](https://docs.gitlab.com/ee/user/project/merge_requests/creating_merge_requests.html)
- [ ] [Automatically close issues from merge requests](https://docs.gitlab.com/ee/user/project/issues/managing_issues.html#closing-issues-automatically)
- [ ] [Enable merge request approvals](https://docs.gitlab.com/ee/user/project/merge_requests/approvals/)
- [ ] [Automatically merge when pipeline succeeds](https://docs.gitlab.com/ee/user/project/merge_requests/merge_when_pipeline_succeeds.html)

## Test and Deploy

Use the built-in continuous integration in GitLab.

- [ ] [Get started with GitLab CI/CD](https://docs.gitlab.com/ee/ci/quick_start/index.html)
- [ ] [Analyze your code for known vulnerabilities with Static Application Security Testing(SAST)](https://docs.gitlab.com/ee/user/application_security/sast/)
- [ ] [Deploy to Kubernetes, Amazon EC2, or Amazon ECS using Auto Deploy](https://docs.gitlab.com/ee/topics/autodevops/requirements.html)
- [ ] [Use pull-based deployments for improved Kubernetes management](https://docs.gitlab.com/ee/user/clusters/agent/)
- [ ] [Set up protected environments](https://docs.gitlab.com/ee/ci/environments/protected_environments.html)

***

# Editing this README

When you're ready to make this README your own, just edit this file and use the handy template below (or feel free to structure it however you want - this is just a starting point!). Thank you to [makeareadme.com](https://www.makeareadme.com/) for this template.

## Suggestions for a good README
Every project is different, so consider which of these sections apply to yours. The sections used in the template are suggestions for most open source projects. Also keep in mind that while a README can be too long and detailed, too long is better than too short. If you think your README is too long, consider utilizing another form of documentation rather than cutting out information.

## Name
Week 10 WF8 and FW9

## Description
It started with the FW8 function for USB. To activate this function you must uncomment the following lines in the while(1):
 /*
lcd_handler_run();
char buff[] = "Hello I'm Sebastian \r\n";
CDC_Transmit_HS((uint8_t *) buff, (uint16_t) strlen(buff));
HAL_Delay(1000);*/

Subsequently, the function to activate the STM32 touch was carried out. To activate the communication by UART, you must uncomment the line in the while(1) :i2c_touch_handler();
And you must also uncomment the initialization line i2c_touch_init(); .

For the SDRAM part, Implement the write, and read functions to store, data into the SDRAM, and print the value read through UART. You must uncomment the following lines before the while(1):
  /*
  // Write, Read and print SDRAM
  // Data and addresses
  uint32_t addr = 0xD0000000; // Address in SDRAM to write
  uint32_t data = 0xB7;       // Value to write in the address

  // Write data to SDRAM
  //sdram_write(addr, data);
  HAL_SDRAM_Write_8b(&hsdram1, (uint32_t *)(addr), (uint8_t *)&data, 4);
  // Read data from SDRAM
  uint32_t read_data;.
  HAL_SDRAM_Read_8b(&hsdram1, (uint32_t *)(addr), (uint8_t *)&read_data, 4);
  // Print value read by UART
  print_value(read_data)*/;

Finally, the screen was configured to be able to print images. In this the change was made by an image of the git icon in a blue background. To upgrade the LCD it is necessary to uncomment the following lines: lcd_handler_run(); HAL_Delay(16);

The new image array was added in a new library called Image1.c
and the following tool was used to convert the image to an array https://notisrac.github.io/FileToCArray/, then it was replaced in the lcd_manager.h library like this:

//#include "lcd_image.h"
#include "Image1.h"

==
NOTE: All the functions were active in the main, to validate the 4 points made, the one that presents delays is the touch since the delay of the USB and LCD functions. In order for it to run without these delays, only the other functions should be commented out.
==


## Badges
On some READMEs, you may see small images that convey metadata, such as whether or not all the tests are passing for the project. You can use Shields to add some to your README. Many services also have instructions for adding a badge.

## Visuals
==
image link with the results of the 4 activities: https://sebastian57.pixieset.com/week10wf8andfw9/
==
## Installation
Within a particular ecosystem, there may be a common way of installing things, such as using Yarn, NuGet, or Homebrew. However, consider the possibility that whoever is reading your README is a novice and would like more guidance. Listing specific steps helps remove ambiguity and gets people to using your project as quickly as possible. If it only runs in a specific context like a particular programming language version or operating system or has dependencies that have to be installed manually, also add a Requirements subsection.

## Usage
Use examples liberally, and show the expected output if you can. It's helpful to have inline the smallest example of usage that you can demonstrate, while providing links to more sophisticated examples if they are too long to reasonably include in the README.

## Support
Tell people where they can go to for help. It can be any combination of an issue tracker, a chat room, an email address, etc.

## Roadmap
If you have ideas for releases in the future, it is a good idea to list them in the README.

## Contributing
State if you are open to contributions and what your requirements are for accepting them.

For people who want to make changes to your project, it's helpful to have some documentation on how to get started. Perhaps there is a script that they should run or some environment variables that they need to set. Make these steps explicit. These instructions could also be useful to your future self.

You can also document commands to lint the code or run tests. These steps help to ensure high code quality and reduce the likelihood that the changes inadvertently break something. Having instructions for running tests is especially helpful if it requires external setup, such as starting a Selenium server for testing in a browser.

## Authors and acknowledgment
Show your appreciation to those who have contributed to the project.

## License
For open source projects, say how it is licensed.

## Project status
If you have run out of energy or time for your project, put a note at the top of the README saying that development has slowed down or stopped completely. Someone may choose to fork your project or volunteer to step in as a maintainer or owner, allowing your project to keep going. You can also make an explicit request for maintainers.
